select
    an.numero as "Nmero"
    , an.brincoeletronico as "Brinco eletrnico"
    , an.dtnascimento as "Data de nascimento"
    , pri.hrpeso as "Hora da primeira pesagem"
    , pri.dtpeso as "Data da primeira pesagem"
    , pri.peso as "Peso na primeira pesagem"
    , penult.hrpeso as "Hora da penltima pesagem"
    , penult.dtpeso as "Data da penltima pesagem"
    , penult.peso as "Peso na penltima pesagem"
    , ult.hrpeso as "Hora da ltima pesagem"
    , ult.dtpeso as "Data da ltima pesagem"
    , ult.peso as "Peso na ltima pesagem"
from
  animal an
  left join peso pri on pri.cdpeso =
    (select first 1 re.cdpeso from peso re where re.cdanimal = an.cdanimal and re.dtpeso >= an.dtentfazenda order by re.dtpeso asc)
  left join peso ult on ult.cdpeso =
    (select first 1 re.cdpeso from peso re where re.cdanimal = pri.cdanimal and re.dtpeso > pri.dtpeso order by re.dtpeso desc)
  left join peso penult on penult.cdpeso =  
    (select first 1 re.cdpeso from peso re where re.cdanimal = ult.cdanimal and re.dtpeso < ult.dtpeso and re.dtpeso > pri.dtpeso order by re.dtpeso desc)
where
  an.tipoanimal = 'A'
  and an.animalrebanho = 1
  and an.dtbaixa is null

